%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Connectivity_Group = Element_Connectivity_Group(Elm_ID, Element_list)

% Существование элемента из списка Elm_ID должно проверяться вне данной функции до ее вызова
% Существование элементов из списка Element_list должно проверяться вне данной функции до ее вызова

% Функция возвращает группу связанности элемента Elm_ID среди элементов массива Element_list

global DB_ELEMENTS;
global AT_ELEMENTS;

if (isempty(Element_list))
    Connectivity_Group = [];
    return;
end

if (~ismember(Elm_ID, Element_list))
    Connectivity_Group = [];
    return;
end

Connectivity_Group = Elm_ID;

Accociated_elm_list = intersect(Get_Elements_From_Nodes(DB_ELEMENTS{AT_ELEMENTS(Elm_ID)}.Nodes, Elm_ID), Element_list);

if (isempty(Accociated_elm_list))
    return;
end

Connectivity_Group = Union_Column(Connectivity_Group, Accociated_elm_list);

Reduced_Element_list = setdiff(Element_list, Connectivity_Group);

if (isempty(Reduced_Element_list))
    return;
end

for i=1:numel(Accociated_elm_list)
    
    Local_Connectivity_Group = Element_Connectivity_Group(Accociated_elm_list(i), Union_Column(Reduced_Element_list, Accociated_elm_list(i)));
    
    Connectivity_Group = Union_Column(Connectivity_Group, Local_Connectivity_Group);
    
    Reduced_Element_list = setdiff(Reduced_Element_list, Local_Connectivity_Group);
    
    if (isempty(Reduced_Element_list))
        break;
    end
    
end
